(* Changing the configuration of noForth T duo (Current use~29.5mA)

    CFG      = Clock frequency in Hz
    CFG 04 + = Used UART ( 0 or 1 ) only 0 is valid for now
    CFG 08 + = Baudrate in bits per second 
    CFG 0C + = Used GPIO pin for S?
    CFG 10 + = Boot method
    
    GROW     = Resize noForth with the number of bytes from the stack

Valid data for these parameters are:
    Clock    = 12, 30, 60, 120, 125, 132, 200 & 250 MHz
    Uart     = 0  (will be upgraded when this version is stable)
    Baudrate = Any baudrate like 9600, 115200 until 921600 was tested ok
    S? pin   = GPIO 24, but any free GPIO pin will do
    Boot     = 0 = Boot only low image, 1 = Boot low, load second image
               2 = Load & boot both images

    FREEZE   = Save bootup images
    FREEZE2  = Save spare images
    COLD     = (Re)load bootup images
    COLD2    = (Re)load spare images

*)

decimal  cfg

125     over !  cell+   \ Set frequency in MHz

0       over !  cell+   \ Use UART-0

38400   over !  cell+   \ Baudrate is 38k4

24      over !  cell+   \ Use GPIO-24 for S?

dup h@ [if]             \ Is it noForth duo?

2       over !          \ Yes, load & start second image too

[then]

drop  hex

  cfg config    \ Test new configuration

\ freeze        \ Save new configuration, boots at startup & when you type COLD
\ freeze2       \ Save as spare system, boots when you type COLD2

\ End
