\ Extended assembler opcodes for RP2040, 1104 bytes.

here
v: inside also  assembler also definitions
100 constant APSR     101 constant IAPSR    102 constant EAPSR
103 constant XPSR     105 constant IPSR     106 constant EPSR
107 constant IEPSR    108 constant MSP      109 constant PSP
110 constant PRIMASK  114 constant CONTROL


v: inside definitions
: ?SPECIAL  ( r -- +n )     100 xor  dup 14 u> ?abort ; \ 0 to 14 valid

BE00 1reg+imm8 BKPT)    DE00 1reg+imm8 UDF)     DF00 1reg+imm8 SVC)


v: assembler definitions \ Hint instructions!
: NOP,      BF00 h, ;      : YIELD,    BF10 h, ;
: WFI,      BF30 h, ;


\ 32-bits no operand opcodes barrier opcodes
: DSB,      F3BF8F4F 32b, ;  : DMB,      F3BF8F5F 32b, ;
: ISB,      F3BF8F6F 32b, ;


\ 32-bits 2 operand opcodes, special register opcodes
: MSR,      ( spr Rn -- )   \ <spec> Rn msr
    0F ?regs 10 lshift  F3808800 or  swap ?special  or 32b, ;
: MRS,      ( rd spr -- )   \ Rd <spec> mrs
    ?special  F3EF8000 or  swap 0F ?regs 08 lshift  or 32b, ;


\ Compose slightly different opcodes, supervisor & breakpoint
B200 2low-reg SXTH,   B240 2low-reg SXTB,   B280 2low-reg UXTH,
B2C0 2low-reg UXTB,   BA00 2low-reg REV,    BA40 2low-reg REV16,

5600 3low-reg LDRSB3) 5E00 3low-reg LDRSH3)
: LDRSB,    ( i*x -- )      ) ?mode  ldrsb3) ;
: LDRSH,    ( i*x -- )      ) ?mode  ldrsh3) ;

: RSBS,     x) ?mode  false ?range-u  neg, ; \ Rd Rn 0 # rsbs

BAC0 2low-reg REVSH,          : SVC,      moon -rot svc) ;
: BKPT,     r0 -rot bkpt) ;   : UDF,      r0 -rot udf) ;

shield +ASM\
here swap - dm .
v: fresh

\ End
